# -*- coding: cp1252 -*-

# Script para produo de mapas de ocorrncia de espcies no Brasil e Amrica do Sul
# Elaborao Flvia Batista-NGeo-RAN


import arcpy, traceback, sys, datetime
import os
from arcpy.mapping import *
#CUR_DATE = datetime.date.today().strftime('%m.%d.%y.')
#Este script gera automaticamente mapas pdf e projetos mxd para cada um dos shapefiles de uma srie. Para rodar o programa vc deve copiar e colar
# na janela do phyton no ArcMap, e rodar. Na janela vo aparecer os avisos e reportadas algumas propriedades que eu escolhi apenas para
#acompanhar o andamento do processo e, enquanto isso, na pasta que vc endereou na varivel mappath abaixo, vo aparecer os mapas e os mxd. Ateno
#estamos partindo do princpio que cada shapefile tem o nome da espcie de que ele trata, e este vai ser o nome do mapa, do mxd, e vai aparecer na legenda.
#isso pode ser modificado, mas s funciona de forma padronizada (mesma lgica para todos os mapas).
#Tambm d para rodar o script atravs do arc catalog,  s criar uma nova caixa de ferramentas e adicionar o script. Isso requer uma explicao mais detalhada.
#IMPORTANTE no toque no computador enquanto ele roda este script! ele d pau mesmo,  pesado.
#se estiver com dois pcs use um s para rodar isso enquanto trabalha no outro, ou... tome uns cafs!
#Abaixo so os parmetros que vc dita, se for rodar o script atravs da janela do python no arc map, os quatro parmetros abaixo precisam ser editados:

datapath = 'C:\\ProGeotos\\' #EDITAR!!!coloque aqui o caminho para a pasta onde esto os shapefiles das espcies
mappath = 'C:\\ProGeotos\\' #EDITAR!!!coloque aqui o caminho para a pasta onde sero salvos os mapas pdf
mxd = arcpy.mapping.MapDocument('CURRENT') #NO EDITAR!!! 

#Neste caso vc tem que ter um shapefile para cada espcie adicionado no projeto mxd,
#todos adicionados porm invisveis (desmarque a caixa). Os shapefiles do seu mapa base tem que estar visveis (imagem, divisao dos estados, etc)
#Se vc estiver usando dos dataframes o segundo no precisa conter os shapes de espcies, o script se encarrega de copiar do primeiro data frame
#a espcie 'da vez' e dar um zoom to layer no segundo data frame (que tem que ficar com no nome 'defalut' New Data Frame


#captura os data fames e layers de toda a tabela de conteudo:
df = ListDataFrames(mxd, 'Menor')[0]
DataFrame=ListDataFrames(mxd, 'Maior')[0]


spp = ListLayers(mxd)
feat_layer = ListLayers(mxd, "IUCN_anfibios_brasil")[0]


#loop atravs dos layers. Aqui o script realiza vrios ciclos, um para cada espcie que tem shape invisivel no seu mxd. O nome do shape
# tem que ser o nome da espcie escrito corretamente, sem espao nem trao baixo. Este nome vai para a legenda, e ser o nome do novo mxd e do pdf

for layer in spp:
    if layer.visible == False:
        print 'nome do Layer: ' + str(layer.name)


        layer.visible = True
#define variveis que sero usadas dentro do looping
        variavel = str(layer.name)
        query = '"BINOMIAL" = \' '+variavel+' \'' 
        out_poly_fc = 'iucnPoli.shp'
        
        arcpy.ApplySymbologyFromLayer_management(layer, 'C:\\ProGEOtos\\anfibios\\modelo_EOO.lyr' )  # EDITAR!!! Colocar o caminho para um layer que vc fez previamente,
        #com a configurao que vc quer que aparea no seu projeto. Atente para a barra invertida dupla.
        #Se for fazer mapas de EOO o modelo tem que ser um Layer de polgono, se for
        #mapa de pontos de registros tem que ser layer de pontos

        arcpy.SelectLayerByAttribute_management(feat_layer, "NEW_SELECTION", query)

        arcpy.CopyFeatures_management(feat_layer, out_poly_fc)
        
        iucnLyr = ListLayers(mxd, "iucnPoli")[0]
        
        arcpy.ApplySymbologyFromLayer_management(iucnLyr, 'C:\\ProGEOtos\\anfibios\\modelo_EOO.lyr' )
        
        arcpy.SelectLayerByAttribute_management (feat_layer,'CLEAR_SELECTION','')
        
        # Abaixo, uma forma de automatizar a deciso entre um e dois frames, mas deixa o script pesado e trava, porisso est setado para nao rodar
               
        # Definir variveis que sero utilizadas
        inFeatures = layer.name
        fieldName = "areaclass"
        fieldPrecision = 11
        fieldScale = 8
       
        expression = "getClass(float(!SHAPE.area!))"
        codeblock = """def getClass(area):
            if area <= 40000000000:
                return 2
            if area > 40000000000:
                return 1"""
 
        # ExecutarAddField
        arcpy.AddField_management(inFeatures, fieldName, "SHORT")
        
         
        # Executar CalculateField 
        arcpy.CalculateField_management(inFeatures, fieldName, expression, "PYTHON", codeblock)

        

        rows = arcpy.SearchCursor(inFeatures)
        
        for row in rows:
            numframes = row.getValue('areaclass')
        if numframes == 2:
            extentPoly = mappath + os.sep + "extent.shp"
            # Feature extent
            #
                      

        # Criar a funo extent 

            extent = arcpy.Describe(layer).extent

        # Criar a funo extent que servir para ancorar os vrtices do Array
            
            array = arcpy.Array()

            #pt1 = extent.lowerLeft
            #pt2 = extent.lowerRight
            #pt3 = extent.upperRight
            #pt4 = extent.upperLeft

            Mex = extent.XMin 
            Mey = extent.YMin
            Max = extent.XMax
            May = extent.YMax

            Menx = Mex - 1
            Meny = Mey - 1
            Maix = Max + 1
            Maiy = May + 1
            
            difx= Maix - Menx
            dify= Maiy - Meny

            if difx > dify:
                val= (difx - dify)/2
                Meny=Meny-val           
                Maiy=Maiy+val
                
            if difx < dify:
                val=(dify-difx)/2
                Menx=Menx-val           
                Maix=Maix+val
           
            #print pt1
            #print xt2yx
            #print xt3yx
            #print pt4

            #print Mex
            #print Mey
            #print Max
            #print May    
            # Podemos criar um Array que  um bounding box, mas ser retangular e no quadrado, alm de ser muito justo em cima da feature.
            #array.add(pt1)
            #array.add(pt2)
            #array.add(pt3)
            #array.add(pt4)
            # Fechar o poligono
            #array.add(pt1)
            
            #Uma opo melhor  usar os vrtices para calcular um Array um pouco maior e quadrado, porm utiliza mais processamento.

            pta = arcpy.Point(Menx, Meny)

            ptb= arcpy.Point(Menx, Maiy)
            ptc= arcpy.Point(Maix, Maiy)
            ptd= arcpy.Point(Maix, Meny)
            
            array.add(pta)
            array.add(ptb)
            array.add(ptc)
            array.add(ptd)
            # Fechar o polgono
            array.add(pta)
            
            # Criar o objeto polgono
            polygon = arcpy.Polygon(array)
            array.removeAll()

            
            #  Como sero vris voltas no loop, precisamos configurar para "salvar por cima" Geoprocessing/ geoprocessing options / overwrite true
            arcpy.CopyFeatures_management(polygon, extentPoly)
            del polygon
            
            
        if numframes == 1:
            print 1
            extentPoly = mappath + os.sep + "extent.shp"

        # Criar a funo extent 

            extent = arcpy.Describe(layer).extent

        # Criar a funo extent que servir para ancorar os vrtices do Array
            
            array = arcpy.Array()

            pt1 = arcpy.Point(-90,-90)
            pt2 = arcpy.Point(-31,-90)
            pt3 = arcpy.Point(-91,-89)
            pt4 = arcpy.Point(-90,-89)

            array.add(pt1)
            array.add(pt2)
            array.add(pt3)
            array.add(pt4)
            # Fechar o poligono
            array.add(pt1)
            
            # Create the polygon object
            polygon = arcpy.Polygon(array)
            array.removeAll()

            
            # save to disk . Mas no nosso caso, como sero vris voltas no loop, precisamos configurar para "salvar por cima" Geoprocessing/ geoprocessing options / overwrite true
            arcpy.CopyFeatures_management(polygon, extentPoly)
            del polygon 
        #o que vemos formatado em amarelo no mapa  o extentPoly, a cpia do polygon. O polygon  s para servir de base, ele  deletado para no aparecerem dois quadrados     
        #A seguir o programa trata do segundo data frame, se vc tiver somente um data frame vai dar erro.
        #Neste caso vc deve apagar ou colocar no inicio de cada linha o sinal de comentrio (#) nas prximas 6 linhas de programa
        #(j deixei o # no final da linha, arraste para o inicio)
        #Outra coisa, este segundo dataframe difere do primeiro apenas pelo zoom to layer. O mapa bsico  o que vc definir no mxd, e o shape que muda
        #para cada ciclo  o mesmo que muda no primeiro data frame, porm no segundo data frame ele recebe zoom.

                 
        
        
        AddLayer(df, layer) #
         # arcpy.RefreshTOC()
                
        
        
        if numframes == 1:
        # Reposicionar o dataframe menor e escala
            df.elementPositionX, df.elementPositionY = -10, -10
            for elmM in arcpy.mapping.ListLayoutElements(mxd, "MAPSURROUND_ELEMENT"):
                if elmM.name == "escalamenor":
                    elmM.elementPositionX = -10
                    elmM.elementPositionY = -10
        # Reposicionar o retangulo que envolve o poligono no mapa maior
    
            for elm in arcpy.mapping.ListLayoutElements(mxd, "GRAPHIC_ELEMENT"):
                if elm.name == "Rectangle":
                    elm.elementPositionX = -10
                    elm.elementPositionY = -10
            

        if numframes == 2:
            arcpy.SelectLayerByAttribute_management (layer,'NEW_SELECTION','') #
            df.extent = layer.getSelectedExtent()  #
            df.scale = df.scale * 1.1
            arcpy.SelectLayerByAttribute_management (layer,'CLEAR_SELECTION','')  #
        # Reposicionar o dataframe menor e escala
            df.elementPositionX, df.elementPositionY = 15.7393, 7.0988
            for elmM in arcpy.mapping.ListLayoutElements(mxd, "MAPSURROUND_ELEMENT"):
                if elmM.name == "escalamenor":
                    elmM.elementPositionX = 16.092
                    elmM.elementPositionY = 6.2601
            for elm in arcpy.mapping.ListLayoutElements(mxd, "GRAPHIC_ELEMENT"):
        # Reposicionar o retangulo que envolve o poligono no mapa maior
                if elm.name == "Rectangle":
                    elm.elementPositionX = 1
                    elm.elementPositionY = 1




        arcpy.RefreshActiveView() 
        mxd.saveACopy(mappath +  layer.name + '.mxd') # Aqui ele salva seu projeto com o nome da espcie, este  o nome que vai para a legenda
       
        ExportToPDF(mxd, mappath + layer.name + '.pdf') # Aqui ele salva o pdf. se prefirir exportar para jpeg  so substituir aqui:
        # ExportToPDF por ExportToJPEG, e layer.name + '.pdf' por layer.name + '.jpg'
        print 'Created : ' +  layer.name + '.pdf'
        layer.visible = False  

        for lyr in arcpy.mapping.ListLayers(mxd, "*",df):
            if lyr.name == layer.name:
                arcpy.mapping.RemoveLayer(df, lyr)

        if arcpy.Exists(iucnLyr):
            arcpy.mapping.RemoveLayer(DataFrame,iucnLyr)
               
                       
        

        #Ateno: se no estiver utilizando a legenda dinmica, e sim uma figura de legenda, e se quiser colocar o nome da espcie no ttulo,
        # s inserir um ttulo com texto dinmico no seu layout e ancorar a caixa pela centro. Este texto dinamico deve ser o nome do projeto,
        #que est programado para ser o nome do shapefile, que como combinamos tem que ser o nome da espcie digitado corretamente. Neste caso nada se altera na legenda!!!
        #Se quiser que cada mapa tenha uma legenda diferente isso ainda teria que ser includo no programa.

print 'Salvo com sucesso'
